#include "Defaults.h"

#include "Color.h"
#include "Vector3D.h"
#include "MapObject.h"

bool unitSemaphore = false;

UnitMap unitMap;
ActionMap actionMap;
PlayerMap playerMap;
StrategyMap strategyMap;

std::vector<std::string> statusBuffer;

char fpsString[10];

Color red = Color(1.0,0.0,0.0,1.0);
Color green = Color(0.0,1.0,0.0,1.0);
Color blue = Color(0.0,0.0,1.0,1.0);
Color yellow = Color(1.0,1.0,0.0,1.0);
Color white = Color(1.0,1.0,1.0,1.0);
Color transparentBlue = Color(0.0,0.0,1.0,0.1);

// default config values

double viewDistance = 1500.0;

bool debug = false;
bool renderText = true;
bool showAttackRanges = false;
bool displayObjectInfo = true;
bool draw3DTextInfo = true;
bool paused = false;

// for window
int windowX = 150;
int windowY = 150;
int windowWidth = 600;
int windowHeight = 400;

// for camera
double yaw = 0.0;
double pitch = 0.0;
double roll = 0.0;

Vector3D cameraPos = Vector3D(0.0,0.0,-150.0);
double cameraSpeed = 10.0;

unsigned int statusBufferSize = 5;
bool smallFont = true;

double fps = 0.0;
std::string groupSaveFile = "groups.sav";

Vector3D statusMessagePos = Vector3D(20.0,20.0,0.0);

std::string configFile = "config.dat";
std::string groupFile = "groups.dat";
std::string unitFile = "units.dat";
std::string actionFile = "actions.dat";
std::string strategyFile = "strategies.dat";

bool mapObjectComparison(const MapObject* a,const MapObject* b){
	return a->getID() < b->getID();
}

MapObjectSet selectedObjects(mapObjectComparison);

