#include "Unit.h"

Unit::Unit(){
	this->name = "default";
	this->moveSpeed = 0.0;
	this->attackRate = 0.0;
	this->attackRange = 0.0;
	this->attackPower = 0.0;
	this->hitPoints = 0.0;
	this->armor = 0.0;
}

Unit::Unit(const Unit& u){
	name = u.getName();
	moveSpeed = u.getMoveSpeed();
	attackRate = u.getAttackRate();
	attackRange = u.getAttackRange();
	attackPower = u.getAttackPower();
	hitPoints = u.getHitPoints();
	armor = u.getArmor();
}

Unit::~Unit(){
	
}

void Unit::setName(const std::string& name){
	this->name = name;
}
void Unit::setMoveSpeed(double moveSpeed){
	this->moveSpeed = moveSpeed;
}
void Unit::setAttackRate(double attackRate){
	this->attackRate = attackRate;
}
void Unit::setAttackRange(double attackRange){
	this->attackRange = attackRange;
}
void Unit::setAttackPower(double attackPower){
	this->attackPower = attackPower;
}
void Unit::setHitPoints(double hitPoints){
	this->hitPoints = hitPoints;
}
void Unit::setArmor(double armor){
	this->armor = armor;
}

std::string Unit::getName() const{
	return name;	
}
double Unit::getMoveSpeed() const{
	return moveSpeed;
}
double Unit::getAttackRate() const{
	return attackRate;
}
double Unit::getAttackRange() const{
	return attackRange;
}
double Unit::getAttackPower() const{
	return attackPower;
}
double Unit::getHitPoints() const{
	return hitPoints;
}
double Unit::getArmor() const{
	return armor;
}


std::string Unit::toString(){
	std::ostringstream stream;
	
	stream << "unit: "  <<  name << "\n";
	stream << "move_speed " << moveSpeed << "\n";
	stream << "attack_rate " << attackRate << "\n";
	stream << "hp " << hitPoints << "\n";
	stream << "attack_power " << attackPower << "\n";
	stream << "armor " << armor << "\n";
	stream << "end" << "\n";
	
	return stream.str();
}

