#ifndef UNIT_H
#define UNIT_H

#include <string>
#include <sstream>

class Unit{
	
public:
	Unit();
	Unit(const Unit& u);
	~Unit();

	void setName(const std::string& name);
	void setMoveSpeed(double moveSpeed);
	void setAttackRate(double attackRate);
	void setAttackRange(double attackRange);
	void setAttackPower(double attackPower);
	void setHitPoints(double hitPoints);
	void setArmor(double armor);
	
	std::string getName() const;
	double getMoveSpeed() const;
	double getAttackRate() const;
	double getAttackRange() const;
	double getAttackPower() const;
	double getHitPoints() const;
	double getArmor() const;
	
	std::string toString();
	
private:
	std::string name;
	double moveSpeed;
	double attackRate;
	double attackRange;
	double attackPower;
	double hitPoints;
	double armor;
};

#endif

