#ifndef MyEventhandler_H
#define MyEventhandler_H

// $Id: MyEventHandler.H,v 1.2 2005/06/13 16:22:47 orts_mburo Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "SE/se_dcdt.h"
#include "EventHandler.H"
#include "GameStateModule.H"
#include "GfxModule.H"
#include "PWidget.H"
#include "ClientState.H"
#include "GameChanges.H"
#include "GameObj.H"
#include "PathEvent.H"
#include "pathfind.h"
#include "PathProcessor.H"
#include "SegmentMerge.H"

using namespace PathFind;

class MyEventHandler : public EventHandler
{
  ClientState &state;
  PWidget* widget;
    
  sint4 DISPLACEMENT; // distance of dcdt bounding box from edges, 2*: world box
  
  sint4 width;
  sint4 height;
    
  sint4 widget_width;
  sint4 widget_height;
    
  sint4 previous_size;

  SeDcdt *dcdt;

  SegmentMerge sm;
  
  //PolyGraph* my_graph;
  //MyPathfindEnvironment mpe;
  //PathProcessor pp;
  //Vector<Decomp::Rect> obstacles;
    
public:
    
  MyEventHandler(ClientState &c);
    
  typedef void (*Handler)(const std::string &from, const std::string &what);
    
  bool handle_event(const Event& e);
    
  ~MyEventHandler();
    
  void draw();
    
  void insert_segment(const DCDT::Segment &);
    
  void initialize_decomposition();
    
  // void insert_into_decomposition(const Segment2i &s);

  void insert_into_decomposition(GameObj* obj);
    
  void display_decomposition();

  void build_graph();

  void draw_graph();

  void draw_paths();

  void set_graph_mode(bool);

  void copying_available(bool);

  void print_decomposition();

  // bool find_path(Point2i, Point2i, UnitPath &);

  //bool exist(Decomp::Node* n, const Vector<Decomp::Node*> &v);

  //Corridor MyEventHandler::compute_corridor(Decomp::Node* n1, Decomp::Node* n2);

  // Vector<Point2i> smooth_path(Vector<Point2i> &oldpath);

  // bool block_by_obstacles(Point2i p1, Point2i p2);
    
  //bool intersect(Decomp::Rect &r, Point2i p1, Point2i p2);

  // if the point falls on the boundary of a free-space node and a obstacle-space node
  //Decomp::Node* get_adjacent_node(Point2i,Decomp::Node* );

  //Point2i get_escape_point(Point2i, Decomp::Node*);
    
  //void test();
};
#endif
