//-----------------------------------------------------------------------------
/** @file search.h
    Search algorithms.

    $Id: hpa_searchutils.h,v 1.1 2005/01/14 22:47:52 orts_mburo Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/apps/hpastar/src/hpa_searchutils.h,v $
*/
//-----------------------------------------------------------------------------

#ifndef PATHFIND_SEARCHUTILS_H
#define PATHFIND_SEARCHUTILS_H

#include "hpa_environment.h"

//-----------------------------------------------------------------------------

namespace PathFind
{
    using namespace std;

    class SearchUtils
    {
    public:
        bool checkPathExists(const Environment& env, int start, int target);

        void findRandomStartTarget(const Environment& env,
                                   int& start, int &target);

    private:
        int m_target;

        const Environment* m_env;

        vector<bool> m_mark;

        vector<vector<Environment::Successor> > m_successorStack;

        bool searchPathExists(int node, int depth);
    };
}

//-----------------------------------------------------------------------------

#endif
