/**
  this code was retrieved from http://lists.trolltech.com/qt-interest/2002-04/thread00485-0.html and modified
*/

#include <qlistbox.h> 
#include <qtooltip.h> 

#include "Global.H"
#include "Net_GGSClient.H"
#include "Net_Message.H"
#include "Net_Protocol.H"
#include "Handler.H"

class GQListBoxToolTip : public QToolTip {
public:
    GQListBoxToolTip(QListBox* lb, Handler* handler) : QToolTip(lb->viewport()),
        listbox_(lb), handler_(handler) {
	this->setWakeUpDelay ( 0 );
    };

    void maybeTip(const QPoint& pos) {
        // get pointed item
        QListBoxItem* item = listbox_->itemAt(pos);
        int index = listbox_->index(item);
        if (item == 0) {
            return;
        }
       
        // show tooltip if item is not fully visible
        QRect r = listbox_->itemRect(item);
        //r.setWidth(item->width(listbox_));
	 // get iid
       InvitationsList list = handler_->getInvitations();
       Invit_Disc disc = list[index].first;
      
	QString text;
//	text += item->text();
	text += "Game Name: ";
	text += disc.get_game_name();
	text += "\nCreated by: ";
	text += disc.get_owner();
	text +=  "\nGame ID: ";
	text += QString::number( disc.get_iid() );
	text +=  "\nNumber of players : ";
	text +=  QString::number( disc.get_num_players() );
	text +=  " out of ";
	text +=  QString::number( disc.get_max_players() );
	if(disc.get_passprotected()){ text+= "\nPassword is required";}
	if(disc.get_anony_ids()){ text+= "\nYou can join anonymously";}
	if(disc.get_invisible()){ 
	    text += "\nOnly buddies of ";
	    text += disc.get_owner();
	    text += " can see this game";
	}
	text+= "\nOptions: " + disc.get_options();
		       
	tip(r, text);
    }
    
protected:
    QListBox* listbox_;
    Handler* handler_;
};
