#include"emitter.h"

#ifndef min
#define min(x,y) ((x)<(y)?(x):(y))
#endif

Emitter::Emitter(int c,float r,float tl,vec3 p,vec3 pr,vec3 v,vec3 vr,vec3 ac,float f,float fr,float da,float ww,float hh,GLuint texid,GLuint colid)
{
  w=ww;
  h=hh;
  billboard_tex=texid;
  color_tex=colid;
  count=c;
  rate=r;
  pos=p;
  p_rand=pr;
  vel=v;
  v_rand=vr;
  acc=ac;
  fric=f;
  f_rand=fr;
  dalpha=da;

  list=new Particle[count];
  first=last=0;

  limit=tl;
}

void Emitter::newparticle()
{
  list[last].pos=pos+vec3::vrand()*p_rand;
  list[last].vel=vel+vec3::vrand()*v_rand;
  list[last].acc=acc;
  list[last].fric=fric+nrand()*f_rand-f_rand/2;
  list[last].alpha=1.0;

  last=(last+1)%count;
  if(last==first)first=(first+1)%count;
}

void Emitter::update(float dt)
{
  static float create=0;
  for(int i=first;i!=last;i=(i+1)%count)
  {
    list[i].update(dt,dalpha*dt);
    if(list[i].alpha<=0)first=(i+1)%count;
  }

  limit-=dt;
  if(limit>0)
  {
    create+=rate*dt;
    while(create>=1)
    {
      newparticle();
      create--;
    }
  }
}

void Emitter::draw()
{
  mat4 m;
  m.glGetModelview();
  m=m.inv();
  vec3 p1=m*vec4(-w,h,0,0);
  vec3 p2=m*vec4(w,h,0,0);
  vec3 p3=m*vec4(w,-h,0,0);
  vec3 p4=m*vec4(-w,-h,0,0);
  
  
  glEnable(GL_BLEND);
  glDepthMask(GL_FALSE);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  glActiveTexture(GL_TEXTURE0);
  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D,billboard_tex);
  glActiveTexture(GL_TEXTURE1);
  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D,color_tex);
  glColor4f(1,1,1,1);
  glBegin(GL_QUADS);
  for(int i=first;i!=last;i=(i+1)%count)
  {
    glMultiTexCoord1f(GL_TEXTURE1,list[i].alpha);
    glMultiTexCoord2f(GL_TEXTURE0,0,0);
    glVertex3fv(list[i].pos+p1);
    glMultiTexCoord2f(GL_TEXTURE0,0,1);
    glVertex3fv(list[i].pos+p2);
    glMultiTexCoord2f(GL_TEXTURE0,1,1);
    glVertex3fv(list[i].pos+p3);
    glMultiTexCoord2f(GL_TEXTURE0,1,0);
    glVertex3fv(list[i].pos+p4);
  }
  glEnd();
  
  glDepthMask(GL_TRUE);
  glDisable(GL_BLEND);
}
