// $Id: MyEventHandler.C,v 1.28 2005/09/06 05:50:48 orts_furtak Exp $

#include "MyEventHandler.H"
#include "Game.H"

#define BUILD_GRAPH 0

MyEventHandler::MyEventHandler(ClientState &c) :state(c)
{
  widget = 0;

  //  widget_width = 300;
  //  widget_height = 300;

  width = 0;
  height = 0;

  my_graph = NULL;

  decomposition = NULL;

  backup = NULL;
  
  previous_size = 0;

  GRIDSIZE = 6;

  DISPLACEMENT = 20;  

  REDUNDANT = true;

  copying = false;
}

MyEventHandler::~MyEventHandler() {}

void MyEventHandler::set_graph_mode(bool mode)
{
  REDUNDANT = mode;
}

bool MyEventHandler::handle_event(const Event& e)
{
#if 0
  cout << "EVENT HANDLED" << endl; 
  cout << e.get_who() << " " << e.get_what() << endl;
  cout << GfxModule::FROM << " " << GfxModule::ADD_CWIDGETS_MSG << endl;
#endif
  
  if (e.get_who() == GfxModule::FROM) {

    if (e.get_what() == GfxModule::ADD_CWIDGETS_MSG) {
      
      std::cout << "adding widget\n";
	  
      widget = new PWidget();
	  	  
      state.gfxm->add_cwidget(*widget);
      
      //      widget->set_position(50, 200);
      //      widget->set_size(widget_width, widget_height);
      
      widget->turn_on();
    }

  } else if (e.get_who() == GameStateModule::FROM) {

    // cout << "Event: GameStateModule " << e.get_what() << endl;

    if (e.get_what() == GameStateModule::STOP_MSG) exit(0);

    if (e.get_what() == GameStateModule::READ_ERROR_MSG) exit(10);      

#if 0
    
    //handle pathfinding event
    if (e.get_what() == GameStateModule::FIND_PATH) {
      	
      const PathEvent *pe = static_cast<const PathEvent*>(&e);

      Coor3 p  = pe->get_dest();
	
      real4 locX,locY;

      locX = p.x;
      locY = p.y;

      locX *= state.client->get_game().get_tile_points();
      locY *= state.client->get_game().get_tile_points();

      Point2i goal;
      goal.x = (sint4) locX;
      goal.y = (sint4) locY;

      cout<<"start processing"<<endl;

      cout.flush();
	
      FORALL (pe->get_objs(), it) {
	GameObj *obj = *it;

	Point2i curPos;
	curPos.x = obj->get_int("x");
	curPos.y = obj->get_int("y");

	//get rid of immobile objects

	if (obj->has_attr("is_mobile") && obj->get_int("is_mobile") == 0) {
	  exit(-1);
	  continue;
	}

	//handle land unit

	if (obj->get_int("zcat") == Object::ON_LAND) {
	    
	  //cout<<curPos.x<<"--"<<curPos.y<<endl;
		  
	  //cout<<obj->get_int("radius")<<endl;

	  UnitPath new_path(obj);

	  if (find_path(curPos, goal, new_path)) {

	    new_path.source = curPos;
	    new_path.target = goal;
	    pp.add_new_path(new_path);
	
	    new_path.print_path();
	  }
		  
	} else {

	  Vector<sint4> params;

	  params.push_back(goal.x);
	  params.push_back(goal.y);

	  params.push_back(obj->sod.max_speed);

	  obj->set_action("move",params);

	  /*
	    UnitPath new_path(obj);
	    new_path.path.push_back(goal);
	    new_path.path.push_back(curPos);

	    new_path.current_target = 0;
		  
	    pp.add_new_path(new_path);
	  */
	}
	     	    
      }

      cout<<"end finding all path"<<endl;

      //processing unit movements
      if (!pp.paths.empty()) {
	draw_paths();
	draw_graph();
	cout<<"good"<<endl;
	pp.process_paths();
      }

      cout<<"end processing all paths"<<endl;
      return 1;

      //handle objects movement
    }
#endif

    
    if (e.get_what() == GameStateModule::VIEW_MSG) {

      //cout << "width:" << state.client->get_game().get_map().get_width() << endl;
      //cout << "height:" << state.client->get_game().get_map().get_height() << endl;
	  
      //return 0;
	  
      if (width == 0) {

	width = state.gsm->get_game().get_map().get_width();
	height = state.gsm->get_game().get_map().get_height();
	    
	width = width*(state.gsm->get_game().get_tile_points());
	height = height*(state.gsm->get_game().get_tile_points());
	    
	//initialize_decomposition();
	    
	widget->init_world(width+2*DISPLACEMENT,height+2*DISPLACEMENT);

	widget->displacement = DISPLACEMENT;

	//pp.scale = state.gsm->get_game().get_tile_points();
      }
      //return 0;
      //now the decomposition
      if (!decomposition && width != 0) {
	initialize_decomposition();
      }

      //return 0;
	  
      //state.gfxc->process_changes();
	  
      const Vector<ScriptObj*> &boundaries = state.gsm->get_changes().new_boundaries;
	  
#if 0
      if (boundaries.size() == previous_size) {
	return 0;
      } else {
	previous_size = boundaries.size();
      }
#endif

      FORALL (boundaries, it) {

        GameObj *g = (*it)->get_GameObj();
        if (g == 0) continue;
		
	sint4 x  = *g->sod.x1;
	sint4 y  = *g->sod.y1;      
	sint4 x2 = *g->sod.x2;
	sint4 y2 = *g->sod.y2;
		
	Segment2i s;
	s.x1 = x;
	s.y1 = y;
	s.x2 = x2;
	s.y2 = y2;
		
	//std::cout<<s.x1<<" "<<s.y1<<" "<<s.x2<<" "<<s.y2<<std::endl;
	insert_segment(s);
      }

      //handle undestructable objects

	
      bool environment_changed = false;

      Vector<ScriptObj*> objs;
      objs = state.gsm->get_changes().new_objs;

      if (copying) {

	bool dynamic_objects_changed = false;
	    
	if (state.gsm->get_changes().new_objs.empty() &&
	    state.gsm->get_changes().changed_objs.empty() &&
	    state.gsm->get_changes().vanished_objs.empty()) {
	} else {
	  dynamic_objects_changed = false;
	}

	if (dynamic_objects_changed) {
	  Vector<ScriptObj::Ptr> all_units = state.gsm->get_game().get_objs(0); //current player

	  obstacles.clear();

	  //copy the backup graph
	  delete decomposition;
	  decomposition = backup->return_copy();

	  //re-insert all objects
	  FORALL(all_units, i) {
	    ScriptObj* obj = *i;
	    GameObj* g = obj->get_GameObj();
	    if (g)
	      insert_into_decomposition(g);
	  }

	  environment_changed = true;
	}
	    
      } else {
	FORALL (objs, i) {
		  
	  ScriptObj* obj = *i;
	  GameObj* g = obj->get_GameObj();
	  if (g == 0) continue;
              
	  if (g->has_attr("is_mobile") &&
	      g->get_int("is_mobile") == 0 &&
	      g->get_int("zcat") == Object::ON_LAND &&
	      !(g->sod.is_boundary)) {
                
	    insert_into_decomposition(g);
	    environment_changed = true;
	  }
	}
      }

      if (decomposition!=NULL && !boundaries.empty()) {
	environment_changed = true;
      }

      if (environment_changed) {
	    
	build_graph();

	//recalculate paths

	Vector<UnitPath> new_paths;

	FORALL (pp.paths, it) {
		  
	  GameObj *obj = it-> unit;

	  obj->clear_action();
		  
	  Point2i curPos;
	  curPos.x = obj->get_int("x");
	  curPos.y = obj->get_int("y");

	  Vector<sint4> params;

	  params.push_back(curPos.x);
	  params.push_back(curPos.y);

	  params.push_back(*obj->sod.max_speed);

	  obj->set_action("move",params);
		  

	  Point2i goal = it->target;
		  
	  //get rid of immobile objects
	  if (obj->has_attr("is_mobile") && obj->get_int("is_mobile")==0) {
	    continue;
	  }
	  //handle land unit
	  if (obj->get_int("zcat") == Object::ON_LAND) {
			
						
	    UnitPath new_path(obj);

			
	    it->print_path();

	    Point2i previous = it->path.at(it->current_target);

	    cout<<previous.x<<" "<<previous.y<<endl;
			
	    if (find_path(curPos,goal,new_path)) {
			
	      new_path.source = curPos;
	      new_path.target = goal;

	      new_paths.push_back(new_path);
			    			    
	      //pp.add_new_path(new_path);
			    
			    
	      //new_path.print_path();
	    } else {

	      obj->clear_action();

	      Point2i curPos;
	      curPos.x = obj->get_int("x");
	      curPos.y = obj->get_int("y");

	      Vector<sint4> params;

	      params.push_back(curPos.x);
	      params.push_back(curPos.y);

	      params.push_back(*obj->sod.max_speed);

	      obj->set_action("move", params);
			    
	    }
			
	  } else {
			
	    UnitPath new_path(obj);
	    new_path.path.push_back(goal);
	    new_path.path.push_back(curPos);

	    new_path.current_target = 0;

	    new_paths.push_back(new_path);
			
	    //pp.add_new_path(new_path);
	  }

	  pp.remove_all_ground_paths();

	  pp.set_paths(new_paths);
	}
	    
	//processing unit movements
	if (!pp.paths.empty()) {
	  draw_paths();
	  draw_graph();
	  pp.process_paths();
	}
	    
      }
      display_decomposition();
	  
      //draw the graph
      draw_graph();

      //process unit movement
      pp.process_paths();
    }
  }

  //return 1;
   
  draw();

  return 0;
}


void MyEventHandler::insert_segment(Segment2i s)
{
  s.x1 += DISPLACEMENT;
  s.x2 += DISPLACEMENT;
  s.y1 += DISPLACEMENT;
  s.y2 += DISPLACEMENT;
    
  //std::cout<<sets.size()<<std::endl;

  if (sets.empty()) {

    sets.push_back(s);
    insert_into_decomposition(s);
    
  } else {
	  
    FORALL (sets, it) {
      Segment2i cur = *it;
      if (cur.x1 == s.x1 && cur.y1 == s.y1 &&
	  cur.x2 == s.x2 && cur.y2 == s.y2) {
	return;
      }
      if (cur.x1 == s.x2 && cur.y1 == s.y2 &&
	  cur.x2 == s.x1 && cur.y2 == s.y1) {
	return;
      }
    }
	  
    sets.push_back(s);
    insert_into_decomposition(s);
  }
}


void MyEventHandler::draw()
{
  //draw on the widget

  if (widget!=NULL) {

    if (sets.empty()) return;

    //cout<<"ok start";
	  
    widget->empty_lines();
	  
    FORALL(sets, it) widget->insert_line(*it);

    //cout<<"ok end";

    //display_decomposition();
  } else {
  }
}

void MyEventHandler::initialize_decomposition()
{
  decomposition = new SectorDecomp(width+2*DISPLACEMENT,
				   height+2*DISPLACEMENT,
				   width+2*DISPLACEMENT);

  backup = new SectorDecomp(width+2*DISPLACEMENT,
			    height+2*DISPLACEMENT,
			    width+2*DISPLACEMENT);

  //insert the bounding box
  
  Decomp::Rect r;
  
  r.set(DISPLACEMENT-GRIDSIZE, DISPLACEMENT+width+GRIDSIZE,
	DISPLACEMENT-GRIDSIZE, DISPLACEMENT+GRIDSIZE);
  decomposition->insert(r, 1, 1);
  backup->insert(r, 1, 1);
  
  r.set(DISPLACEMENT-GRIDSIZE, DISPLACEMENT+width+GRIDSIZE,
	DISPLACEMENT+height-GRIDSIZE, DISPLACEMENT+height+GRIDSIZE);
  decomposition->insert(r, 1, 1);
  backup->insert(r, 1, 1);
  
  r.set(DISPLACEMENT-GRIDSIZE, DISPLACEMENT+GRIDSIZE,
	DISPLACEMENT-GRIDSIZE, DISPLACEMENT+height+GRIDSIZE);
  decomposition->insert(r, 1, 1);
  backup->insert(r, 1, 1);
  
  r.set(DISPLACEMENT+width-GRIDSIZE, DISPLACEMENT+width+GRIDSIZE,
	DISPLACEMENT-GRIDSIZE, DISPLACEMENT+height+GRIDSIZE);
  decomposition->insert(r, 1, 1);
  backup->insert(r, 1, 1);
}


void MyEventHandler::insert_into_decomposition(Segment2i s)
{
  if (s.x1 == s.x2) {
    //vertical edge
    Decomp::Rect r;
    if (s.y1 < s.y2) {
      r.set(s.x1-GRIDSIZE, s.x1+GRIDSIZE, s.y1-GRIDSIZE, s.y2+GRIDSIZE);
    } else {
      r.set(s.x2-GRIDSIZE, s.x2+GRIDSIZE, s.y2-GRIDSIZE, s.y1+GRIDSIZE);
    }
    decomposition->insert(r, 1, 1);
    backup->insert(r, 1, 1);
    
    obstacles.push_back(r);
    return;
  }

  if (s.y1 == s.y2) {
    //horizontal edge
    Decomp::Rect r;
    if (s.x1 < s.x2) {
      r.set(s.x1-GRIDSIZE, s.x2+GRIDSIZE, s.y1-GRIDSIZE, s.y2+GRIDSIZE);
    } else {
      r.set(s.x2-GRIDSIZE, s.x1+GRIDSIZE, s.y2-GRIDSIZE, s.y2+GRIDSIZE);
    }
    
    decomposition->insert(r, 1, 1);
    backup->insert(r, 1, 1);
    
    obstacles.push_back(r);
    return;
  }
    
  //45 degree
  if (s.x2 < s.x1 && s.y2 < s.y1) {
    Segment2i new_s;
    new_s.x1 = s.x2;
    new_s.x2 = s.x1;
    new_s.y1 = s.y2;
    new_s.y2 = s.y1;

    insert_into_decomposition(new_s);
    return;
  }

  if (s.x1 < s.x2 && s.y1 < s.y2) {

    sint4 curX = s.x1;
    sint4 curY = s.y1;
	  
    int count = 0;
	  
    while(curX <= s.x2) {
      //cout<<count<<endl;
      Decomp::Rect r;
		
      r.set(curX-GRIDSIZE, curX+GRIDSIZE, curY-GRIDSIZE, curY+GRIDSIZE);
		
      decomposition->insert(r,1,1);
      backup->insert(r,1,1);
		
      obstacles.push_back(r);
		
      curX += GRIDSIZE;
      curY += GRIDSIZE;
		
      count++;
    }
	  
    return;
  }
    
  //135 degree
  if (s.x1 < s.x2 && s.y2 < s.y1) {
    Segment2i new_s;
    new_s.x1 = s.x2;
    new_s.x2 = s.x1;
    new_s.y1 = s.y2;
    new_s.y2 = s.y1;

    insert_into_decomposition(new_s);

    return;
  }

  if (s.x2 < s.x1 && s.y1 < s.y2) {
	 
    //r.set(s.x2-GRIDSIZE, s.x1+GRIDSIZE, s.y2-GRIDSIZE, s.y2+GRIDSIZE);

    sint4 curX = s.x1;
    sint4 curY = s.y1;
    while(curX >= s.x2) {

      Decomp::Rect r;
		
      r.set(curX - GRIDSIZE, curX+GRIDSIZE, curY-GRIDSIZE, curY+GRIDSIZE);

      decomposition->insert(r,1,1);
      backup->insert(r,1,1);
		
      obstacles.push_back(r);
		
      curX -= GRIDSIZE;
      curY += GRIDSIZE;
    }
    return;
  }
}

void MyEventHandler::insert_into_decomposition(GameObj* obj)
{
  sint4 x = obj->get_int("x");
  sint4 y = obj->get_int("y");

  x += DISPLACEMENT;
  y += DISPLACEMENT;

  if (obj->get_int("shape")==Object::RECTANGLE) {

    sint4 width = obj->get_int("width");
    sint4 height = obj->get_int("height");

    Decomp::Rect r;
    r.set(x-width/2-GRIDSIZE,x+width/2+GRIDSIZE,y-height/2-GRIDSIZE, y+height/2+GRIDSIZE);

    decomposition->insert(r,1,1);

    obstacles.push_back(r);
	  
  } else if (obj->get_int("shape")==Object::CIRCLE) {
    sint4 radius = obj->get_int("radius");

    Decomp::Rect r;
    r.set(x-radius-GRIDSIZE,x+radius+GRIDSIZE,y-radius-GRIDSIZE,y+radius+GRIDSIZE);

    decomposition->insert(r,1,1);

    obstacles.push_back(r);
  }
    
}
void MyEventHandler::display_decomposition()
{
  if (decomposition==NULL) {
    return;
  }
  widget->set_decomposition(decomposition);
  //widget->display_decomposition = true;
}


//print the decomposition for debugging
void MyEventHandler::print_decomposition()
{
  cout<<"\n/****START****/\n";
    
  FORALL (decomposition->sectors, i) {
	  
    FORALL (i->nodes, j) {
      Decomp::Node *n = *j;
		
      //if (n->type!=Decomp::Node::R_NODE) continue;
		
      n->write();
    }
	  
  }
  cout<<"/****END****/\n";
}


//build the graph from the decomposition

void MyEventHandler::build_graph()
{
#if !BUILD_GRAPH
  my_graph = 0;
  return;
#endif  

  if (decomposition == NULL) {

    return;

  } else {

    if (my_graph != NULL) {

      my_graph->clear_graph();
    }

    my_graph = new PolyGraph();
    
    cout<<"start building graph"<<endl;
    my_graph = new PolyGraph();

    if (REDUNDANT) {
      my_graph->build_graph_redundant(&(decomposition->sectors.front()));
    } else {
      my_graph->build_graph(&(decomposition->sectors.front()));
    }
    cout<<"end building graph"<<endl;

    //exit(-1);
  }
}


void MyEventHandler::draw_graph()
{
  //draw on the widget
  widget->set_graph(my_graph);
  //widget->display_graph = true;
}


void MyEventHandler::draw_paths()
{
  widget->set_paths(&pp);
  //widget->display_path = true;
}


bool MyEventHandler::find_path(Point2i source, Point2i target, UnitPath &path)
{
  if (my_graph==NULL) {
    build_graph();
  }
  
  Decomp::Node* n1 = (decomposition->sectors.front()).locate(source.x+DISPLACEMENT,
							     source.y+DISPLACEMENT);
  Decomp::Node* n2 = (decomposition->sectors.front()).locate(target.x+DISPLACEMENT,
							     target.y+DISPLACEMENT);
  if (n1 == n2) {
	
    path.path.push_back(target);
	
    path.path.push_back(source);

    path.current_target = 0;

    //cout<<"same region"<<endl;
	
    return true;
  }

  bool overshooting = false;

  Point2i escape_point;
  
  if (n1->data == 1 || n2->data == 1) {

    Decomp::Node* t_n1;
    Decomp::Node* t_n2;
	
    if (n2->data == 1) {

      Point2i temp(target.x+DISPLACEMENT, target.y+DISPLACEMENT);
	    
      t_n2 = get_adjacent_node(temp,n2);

      n2 = t_n2;
	    
      if (t_n2 == NULL) {
	return false;
      }
    }

    if (n1->data == 1) {

      cout << "object inside obtacles" << endl;

      n1->write();
	    
      cout<<source.x+DISPLACEMENT<<" "<<source.y + DISPLACEMENT<<endl;

      Point2i temp(source.x+DISPLACEMENT, source.y+DISPLACEMENT);
	    
      t_n1 = get_adjacent_node(temp,n1);

      if (t_n1 == NULL) {
	//handles overshooting problem
	cout << "overshooting" << endl;

	overshooting = true;

	escape_point = get_escape_point(temp, n1);

	n1 = get_adjacent_node(escape_point,n1);
		  
	//exit(-1);
      } else {
	n1 = t_n1;
      }
      //exit(-1);
    } else {
      return false;
    }
  }

  source.x += DISPLACEMENT;
  source.y += DISPLACEMENT;
  target.x += DISPLACEMENT;
  target.y += DISPLACEMENT;
  
  widget->source = n1;
  widget->target = n2;

  
  int node_id_1;
  
  if (!overshooting) {
    node_id_1 = my_graph->insert_node(source, n1);
  } else {
    node_id_1 = my_graph->insert_node(escape_point,n1);
  }
	
  int node_id_2 = my_graph->insert_node(target, n2);
  
  auto_ptr<Search> search;
  
  search.reset(new AStar<MarkerFastClear,
	       AStarOpenBuckets<MarkerFastClear,AStarCompareF>,
	       AStarClosedLookup<MarkerFastClear> >());
  
  search->setNodesLimit(10000);
  
  mpe.attach_graph(my_graph);
  
  mpe.set_start(node_id_1);
  mpe.set_goal(node_id_2);
  
  if (!search->findPath(mpe, node_id_1, node_id_2)) {
    mpe.detach_graph();

    my_graph->delete_last_two_nodes();
		
    return false;
  }
  
  std::vector<int> int_path = search->getPath();
  
  Vector<Point2i> result;

  if ((int)int_path.size() == 0) {

    cout<<"astar returns an empty path"<<endl;

    my_graph->delete_last_two_nodes();
	
    mpe.detach_graph();
    return false;
  }
  
  //convert it to actual_path
  Vector<Decomp::Node*> tunnel;

  Graph_node* previous;
  
  FORALL (int_path, i) {

    int node_id = *i;
	
    Graph_node* cur = my_graph->all_nodes.at(node_id);

    /*
      if (i==int_path.begin()) {
      tunnel.push_back(cur->n2);
      } else {
      if (i!=(int_path.end()-1)) {
	    
      if (cur->n1 == previous->n1) {
      tunnel.push_back(cur->n2);
      } else if (cur->n2 == previous->n1) {
      tunnel.push_back(cur->n1);
      } else if (cur->n1 == previous->n2) {
      tunnel.push_back(cur->n2);
      } else if (cur->n2 == previous->n2) {
      tunnel.push_back(cur->n1);
      } else {
      cout<<"broken path"<<endl;
		  
      }
      }
	    
      }*/

    if (!exist(cur->n1,tunnel)) {
      tunnel.push_back(cur->n1);
    }
    if (!exist(cur->n2,tunnel)) {
      tunnel.push_back(cur->n2);
    }

    previous = cur;
	   
	   
    Point2i p(cur->p.x - DISPLACEMENT, cur->p.y - DISPLACEMENT);
	
    result.push_back(p);
  }

  FORALL(tunnel, i) {
	
    Decomp::Rect new_r;
    new_r.x0 = (*i)->r.x0;
    new_r.x1 = (*i)->r.x1;
    new_r.y0 = (*i)->r.y0;
    new_r.y1 = (*i)->r.y1;
	
    path.tunnel.push_back(new_r);

    //compute corridor through the tunnel
    if (i!=tunnel.begin()) {
      Corridor door = compute_corridor(*(i-1),*i);
      path.doors.push_back(door);
    }
  }

  //path.set_path(result);

  Vector<Point2i> new_result = smooth_path(result);

  if (overshooting) {
    new_result.push_back(Point2i(source.x-DISPLACEMENT, source.y-DISPLACEMENT));
  }
  
  path.set_path(new_result);

  my_graph->delete_last_two_nodes();
  
  //cout<<"different region"<<endl;
  
  int_path.clear();
  
  mpe.detach_graph();
  
  return true;
	

}


bool MyEventHandler::exist(Decomp::Node* n, const Vector<Decomp::Node*> &v) {
  if (n==NULL) return false;

  FORALL (v, i) {
    if (*i == n) return true;
  }

  return false;
}


Corridor MyEventHandler::compute_corridor(Decomp::Node* n1, Decomp::Node* n2)
{
  int number = -1;

  bool found = false;

  FORS (i, 4) {
    FORALL (n1->nl[i], j) {
      if ((*j) == n2) {
	found = true;
	number = i;
	break;
      }
    }
    if (found) break;
  }

  Decomp::Rect r0 = n1->r;
  Decomp::Rect r1 = n2->r;

  Point2i p1, p2, p3, p4;
    
  switch (number) {

    //north
  case 0:
    p1.x = r0.x0;
    p1.y = r0.y1;
    p2.x = r0.x1;
    p2.y = r0.y1;
	  
    p3.x = r1.x0;
    p3.y = r1.y0;
    p4.x = r1.x1;
    p4.y = r1.y0;
    break;

    //east
  case 1:
	  	  
    p1.x = r0.x1;
    p1.y = r0.y1;
    p2.x = r0.x1;
    p2.y = r0.y0;
	  
    p3.x = r1.x0;
    p3.y = r1.y1;
    p4.x = r1.x0;
    p4.y = r1.y0;
	  
    break;
    
    //south
  case 2:
	  	  
    p1.x = r0.x0;
    p1.y = r0.y0;
    p2.x = r0.x1;
    p2.y = r0.y0;
	  
    p3.x = r1.x0;
    p3.y = r1.y1;
    p4.x = r1.x1;
    p4.y = r1.y1;
    break;
    
    //west
  case 3:
	  	  
    p1.x = r0.x0;
    p1.y = r0.y0;
    p2.x = r0.x0;
    p2.y = r0.y1;
	  
    p3.x = r1.x1;
    p3.y = r1.y1;
    p4.x = r1.x1;
    p4.y = r1.y0;

    break;
    
  default:
    cout<<"not two neighbours"<<endl;
    break;

    exit(-1);
	  
  }

  Point2i result1;
  Point2i result2;
    
  if (p1.x == p2.x && p1.x == p3.x && p1.x == p4.x) {
    std::priority_queue<sint4, Vector<sint4>, std::less<sint4> > pq;
    pq.push(p1.y);
    pq.push(p2.y);
    pq.push(p3.y);
    pq.push(p4.y);
	  
    sint4 s1,s2;
    pq.pop();
    s2 = pq.top();
    pq.pop();
    s1 = pq.top();
    pq.pop();
    pq.pop();
	  
    result1.x = p1.x;
    result1.y = s1;
	  
    result2.x = p1.x;
    result2.y = s2;
	  
  }
    
  if (p1.y == p2.y && p1.y == p3.y && p1.y == p4.y) {
	  
    std::priority_queue<sint4, Vector<sint4>, std::less<sint4> > pq;
    pq.push(p1.x);
    pq.push(p2.x);
    pq.push(p3.x);
    pq.push(p4.x);

    sint4 s1,s2;
    pq.pop();
    s2 = pq.top();
    pq.pop();
    s1 = pq.top();
    pq.pop();
    pq.pop();
	  
    result1.x = s1;
    result1.y = p1.y;
	  
    result2.x = s2;
    result2.y = p1.y;
	  	  
  }

  if (result1.x == 0 && result1.y == 0) {
    n1->write();
    n2->write();

    exit(-1);
  }

  Corridor new_corridor(result1,result2);

  return new_corridor;
    
}

Vector<Point2i> MyEventHandler::smooth_path(Vector<Point2i> &oldpath)
{
  Vector<Point2i> result;

  Point2i source = oldpath.back();
  Point2i target = oldpath.front();
    
  result.push_back(target);
    
  Vector<Point2i>::iterator iter = oldpath.end() - 1;

#if 0
  FORALL (oldpath, i) {

    if (i != oldpath.begin()) {
      Point2i p1 = *(i-1);
      Point2i p2 = *i;

      p1.x += DISPLACEMENT;
      p1.y += DISPLACEMENT;
      p2.x += DISPLACEMENT;
      p2.y += DISPLACEMENT;
		
      if (block_by_obstacles(p1,p2)) {
	cout<<"impossible"<<endl;
	exit(-1);
      }
    }

    //result.push_back(*i);

  }
#endif

  int range = oldpath.size()-1;

  int current = 0;

  int next = range;
    
  while(current != range) {

    Point2i p1 = oldpath.at(current);
    Point2i p2 = oldpath.at(next);

    p1.x += DISPLACEMENT;
    p1.y += DISPLACEMENT;
    p2.x += DISPLACEMENT;
    p2.y += DISPLACEMENT;

    cout<<current<<endl;
    cout<<next<<endl;
	  
    if (!block_by_obstacles(p1,p2)) {
      result.push_back(oldpath.at(next));

      if (current == next) {
	cout<<"error"<<endl;
      }
      current = next;

      cout<<"jumping to :"<<current<<endl;
      cout<<"source at: "<<range<<endl;

		
      //reset next to be the source
      next = range;

      continue;
		
    }

    next--;
	  
  }
    
  return result;
}

bool MyEventHandler::block_by_obstacles(Point2i p1, Point2i p2)
{
  FORALL (obstacles, i) {
    if (intersect(*i, p1, p2)) {

      //cout<<i->x0<<" "<<i->x1<<" "<<i->y0<<" "<<i->y1<<endl;
		
      //cout<<p1.x<<" "<<p1.y<<endl;
      //cout<<p2.x<<" "<<p2.y<<endl;
		
      return true;
    }
  }

  return false;

}

//fix me, optimization needed
bool MyEventHandler::intersect(Decomp::Rect &r, Point2i p1, Point2i p2)
{
  //if p1 inside r
  if (p1.x > r.x0 && p1.y > r.y0 && p1.x < r.x1 && p1.y < r.y1) {
    //cout<<"p1"<<endl;
	  
    return true;
  }
  //if p2 inside r
  if (p2.x > r.x0 && p2.y > r.y0 && p2.x < r.x1 && p2.y < r.y1) {

    //cout<<"p2"<<endl;

    return true;
  }

  sint4 x0 = p1.x;
  sint4 y0 = p1.y;
  sint4 x1 = p2.x;
  sint4 y1 = p2.y;

  //vertical line
  if (x0 == x1) {
    if ( x0 > r.x0 && x0 < r.x1) {
      if (y0 <= y1 && y0 <= r.y0 && y1 >= r.y1) {
	return true;
      }
      if (y0 >= y1 && y1 <= r.y0 && y0 >= r.y1) {
	return true;
      }

    }

    return false;
  }

  //horizontal line
  if (y0 == y1) {
    if ( y0 > r.y0 && y0 < r.y1) {
      if ( x0 <= x1 && x0 <= r.x0 && x1 >= r.x1) {
	return true;
      }
      if ( x0 >= x1 && x1 <= r.x0 && x0 >= r.x1) {
	return true;
      }
    }

    return false;
  }

  //test againt four boundaries
  //first
  real4 x = (real4) r.x0;

  real4 y = (((real4)(y1-y0))/((real4)(x1-x0)) * ((real4)(x-x0))) + y0;

  if ( (sint4)y > r.y0 && (sint4)y < r.y1) {

    //test if the point is on the segment p1,p2
    if ( (y - y0)*(y - y1) < 0 && (x-x0)*(x-x1) < 0) {
      //cout<<"A"<<x<<","<<y<<endl;
      return true;
    }
  }

  //second
  x = (real4) r.x1;

  y = (((real4)(y1-y0))/((real4)(x1-x0)) * ((real4)(x-x0))) + y0;

  if ( (sint4)y > r.y0 && (sint4)y < r.y1) {

    //test if the point is on the segment p1,p2
    if ( (y - y0)*(y - y1) < 0 && (x-x0)*(x-x1) <0) {
      //cout<<"B"<<x<<","<<y<<endl;
      return true;
    }
  }
    
  //third
  y = (real4) r.y0;

  x = (((real4)(x1-x0))/((real4)(y1-y0)) * ((real4)(y-y0))) + x0;

  if ( (sint4) x > r.x0 && (sint4)x < r.x1) {

    //test if the point is on the segment p1,p2
    if ( (y - y0)*(y - y1) < 0 && (x-x0)*(x-x1) <0) {
      //cout<<"C"<<x<<","<<y<<endl;
      return true;
    }
	  
  }

  //fourth
  y = (real4) r.y1;

  x = (((real4)(x1-x0))/((real4)(y1-y0)) * ((real4)(y-y0))) + x0;

  if ( (sint4) x > r.x0 && (sint4)x < r.x1) {

    //test if the point is on the segment p1,p2
    if ( (y - y0)*(y - y1) < 0 && (x-x0)*(x-x1) <0) {

      //cout<<"D"<<x<<","<<y<<endl;
		
      return true;
    }
	  
  }
    
  return false;
}

    
Decomp::Node* MyEventHandler::get_adjacent_node(Point2i p,Decomp::Node* n)
{
  if (n==NULL) {
    ERR("null pointer");
  }

  if (n->data!=1) {
    ERR("no need to find the adjacent node");
  }

  Decomp::Node* adjacent_node = 0;

  bool found = false;

  Decomp::Rect r0 = n->r;

  //point on the west boundary
  if (p.x == r0.x0) {
    FORALL (n->nl[3], i) {
      (*i)->write();
      if ((*i)->data==0) {
	Decomp::Rect r1 = (*i)->r;

	if (p.y>= r1.y0 && p.y <= r1.y1) {
	  found = true;
	  adjacent_node = *i;
			  
	  break;
	}
      }
    }
  }
  //point on the east boundary
  if (p.x == r0.x1) {
    FORALL (n->nl[1], i) {
      (*i)->write();
      if ((*i)->data==0) {
	Decomp::Rect r1 = (*i)->r;

	if (p.y>= r1.y0 && p.y <= r1.y1) {
	  found = true;
	  adjacent_node = *i;
	  break;
	}
      }
    }
  }

  //point on the north boundary
  if (p.y == r0.y0) {
    FORALL (n->nl[2], i) {
      (*i)->write();
      if ((*i)->data==0) {
	Decomp::Rect r1 = (*i)->r;

	if (p.x>= r1.x0 && p.x <= r1.x1) {
	  found = true;
	  adjacent_node = *i;
	  break;
	}
      }
    }
  }
  //point on the south boundary
  if (p.y == r0.y1) {
    FORALL (n->nl[0], i) {
      (*i)->write();
      if ((*i)->data==0) {
	Decomp::Rect r1 = (*i)->r;

	if (p.y>= r1.y0 && p.y <= r1.y1) {
	  found = true;
	  adjacent_node = *i;
	  break;
	}
      }
    }
  }
    
  if (!found) {
    cout<<p.x<<" "<<p.y<<endl;
    n->write();
    cout<<"not on boundary"<<endl;
    return NULL;
  }
    
  return adjacent_node;
}

//if the object is inside the obstacle space, find the point to escape
Point2i MyEventHandler::get_escape_point(Point2i current, Decomp::Node* n)
{
  Point2i result;

  if (n==NULL) {
    exit(-1);
  }
  if (n->type != Decomp::Node::R_NODE) {
    exit(-1);
  }
  double dist = 0;

    
  bool found = false;
    
  //search four boundary for the escape exit
  FORALL (n->nl[0], i) {

    if ((*i)->data != n->data) {

      Decomp::Rect r0 = n->r;
      Decomp::Rect r1 = (*i)->r;

      Point2i p1,p2,p3,p4;

      p1.x = r0.x0;
      p1.y = r0.y1;
      p2.x = r0.x1;
      p2.y = r0.y1;
		
      p3.x = r1.x0;
      p3.y = r1.y0;
      p4.x = r1.x1;
      p4.y = r1.y0;
		
      Point2i p = my_graph->get_point(p1, p2, p3, p4);

      if (!found) {
	dist = current.distance(p);
	result = p;
	found = true;
      } else {
	if (current.distance(p) < dist) {
	  dist = current.distance(p);
	  result = p;
	}
      }
    }
  }

  FORALL (n->nl[1], i) {
    if ((*i)->data != n->data) {
		
      Decomp::Rect r0 = n->r;
      Decomp::Rect r1 = (*i)->r;

      Point2i p1,p2,p3,p4;

      p1.x = r0.x1;
      p1.y = r0.y1;
      p2.x = r0.x1;
      p2.y = r0.y0;
		
      p3.x = r1.x0;
      p3.y = r1.y1;
      p4.x = r1.x0;
      p4.y = r1.y0;
		
      Point2i p = my_graph->get_point(p1,p2,p3,p4);

      if (!found) {
	dist = current.distance(p);
	result = p;
	found = true;
      } else {
	if (current.distance(p)<dist) {
	  dist = current.distance(p);
	  result = p;
	}
      }
    }
  }

  FORALL (n->nl[2], i) {
    if ((*i)->data != n->data) {

      Decomp::Rect r0 = n->r;
      Decomp::Rect r1 = (*i)->r;
		
      Point2i p1,p2,p3,p4;

      p1.x = r0.x0;
      p1.y = r0.y0;
      p2.x = r0.x1;
      p2.y = r0.y0;
		
      p3.x = r1.x0;
      p3.y = r1.y1;
      p4.x = r1.x1;
      p4.y = r1.y1;
		
      Point2i p = my_graph->get_point(p1,p2,p3,p4);
		
      if (!found) {
	dist = current.distance(p);
	result = p;
	found = true;
      } else {
	if (current.distance(p)<dist) {
	  dist = current.distance(p);
	  result = p;
	}
      }
    }
  }
  FORALL (n->nl[3], i) {
    if ((*i)->data != n->data) {

      Decomp::Rect r0 = n->r;
      Decomp::Rect r1 = (*i)->r;
		
      Point2i p1,p2,p3,p4;
		
      p1.x = r0.x0;
      p1.y = r0.y0;
      p2.x = r0.x0;
      p2.y = r0.y1;
		
      p3.x = r1.x1;
      p3.y = r1.y1;
      p4.x = r1.x1;
      p4.y = r1.y0;
		
      Point2i p = my_graph->get_point(p1,p2,p3,p4);

      if (!found) {
	dist = current.distance(p);
	result = p;
	found = true;
      } else {
	if (current.distance(p) < dist) {
	  dist = current.distance(p);
	  result = p;
	}
      }
    }
  }

  if (!found) {
    cout << "cannot escape!" << endl;
    exit(-1);
  }
  return result;
}

void MyEventHandler::copying_available(bool value)
{
  copying = value;
}
