#ifndef Frustum_H
#define Frustum_H

// $Id: Frustum.H,v 1.3 2005/05/11 00:26:18 orts_mburo Exp $
 
// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"

class Coor3;

class Frustum {

public:

  void compute();
  bool aabox_intersects(const Coor3 &o, const Coor3 &d);
  bool sphere_intersects(const Coor3 &o, real4 radius);
  bool point_intersects(const Coor3 &o);

  real4 m_Frustum[6][4];

protected:

  enum { A, B, C, D };
  enum { RIGHT, LEFT, BOTTOM, TOP, BACK, FRONT };

  void normalize_plane(real4 frustum[6][4], sint4 side);
};

#endif
