// $Id: KeyMap.C,v 1.2 2005/08/30 05:49:37 orts_furtak Exp $

// This is an ORTS file
// (c) Tim Furtak
// licensed under the GPL

#include "Global.H"
#include <glut.h>
#include "KeyMap.H"

//===================================================================

sint4 KeyMap::glut_key(sint4 k)
{
  return k; // should just be the ascii code
}

//-------------------------------------------------------------------

/** Converts a GLUT special keycode into our implementation independent value. */

sint4 KeyMap::glut_special_key(sint4 k)
{
  switch (k) {
  case GLUT_KEY_F1: return KEY_F1;
  case GLUT_KEY_F2: return KEY_F2;
  case GLUT_KEY_F3: return KEY_F3;
  case GLUT_KEY_F4: return KEY_F4;
  case GLUT_KEY_F5: return KEY_F5;
  case GLUT_KEY_F6: return KEY_F6;
  case GLUT_KEY_F7: return KEY_F7;
  case GLUT_KEY_F8: return KEY_F8;
  case GLUT_KEY_F9: return KEY_F9;
  case GLUT_KEY_F10: return KEY_F10;
  case GLUT_KEY_F11: return KEY_F11;
  case GLUT_KEY_F12: return KEY_F12;

  case GLUT_KEY_LEFT:  return KEY_LEFT;
  case GLUT_KEY_UP:    return KEY_UP;
  case GLUT_KEY_RIGHT: return KEY_RIGHT;
  case GLUT_KEY_DOWN:  return KEY_DOWN;

  case GLUT_KEY_PAGE_UP: return KEY_PAGEUP;
  case GLUT_KEY_PAGE_DOWN: return KEY_PAGEDOWN;
  case GLUT_KEY_HOME:   return KEY_HOME;
  case GLUT_KEY_END:    return KEY_END;
  case GLUT_KEY_INSERT: return KEY_INSERT;
  }
  return 0;
}

//===================================================================
