#ifndef GameChanges_H
#define GameChanges_H

/** @file GameChanges.H
    Wrapper for all the changes in one game cycle.

    $Id: GameChanges.H,v 1.7 2006/04/25 03:08:38 orts_mburo Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/libs/kernel/src/GameChanges.H,v $
*/

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "GameObj.H"

class ScriptObj;

/** Wrapper for all game object changes in one game cycle. */

struct GameChanges
{
  Vector<sint4>    new_tile_indexes;
  Vector<ScriptObj*> new_objs;
  Vector<ScriptObj*> changed_objs;
  Vector<ScriptObj*> vanished_objs;
  Vector<ScriptObj*> dead_objs;
  Vector<ScriptObj*> new_boundaries;

  void clear()
  {
    new_tile_indexes.clear();
    new_objs.clear();
    changed_objs.clear();    
    vanished_objs.clear();
    dead_objs.clear();
    new_boundaries.clear();
  }
    
};


/** Wrapper for action queue changes */

struct ActionChanges
{
  Vector<GameObj::ActInfo> skipped;
  Vector<GameObj::ActInfo> executed;
  // Vector<GameObj::ActInfo> succeeded; 
  // Vector<GameObj::ActInfo> failed;    

  void clear()
  {
    skipped.clear();
    executed.clear();
    //succeeded.clear();
    //failed.clear();
  }

};

#endif

