/** @file GameConst.C
    @see GameConst.H

    $Id: GameConst.C,v 1.4 2006/04/03 00:41:32 orts_mburo Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/libs/kernel/src/GameConst.C,v $
*/

// This is an ORTS file (c) Tim Furtak

#include "Global.H"
#include "GameConst.H"

using namespace std;


sint4 GameConst::encode_dir(sint4 dx, sint4 dy, sint4 max)
{
  real8 angle = atan2(static_cast<double>(dy),static_cast<double>(dx)); // (-pi, pi]
  angle *= M_1_PI; // (-1, 1]
  angle += 1;      // (0, 2]

  sint4 dir = sint4(angle * max); // [0, 2*max]
  dir += 1;                       // [1, 2*max+1]
  dir /= 2;                       // [0, max]
  if (dir == 0) dir = max;
  return dir;
}

real8 GameConst::angle_from_dir(sint4 dir, sint4 max)
{
  return (-360.0 * dir) / max + 180.0;
}

