#ifndef ScriptSet_H
#define ScriptSet_H

/** @file ScriptSet.H

    $Id: ScriptSet.H,v 1.3 2005/07/09 00:42:52 orts_furtak Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/libs/kernel/src/ScriptSet.H,v $
*/

// This is an ORTS file (c) Tim Furtak

#include "Global.H"
#include "GameObj.H"

class PlayerInfo;
class SActParam;

//===================================================================

class ScriptSet : public ScriptObj
{
protected:
  Vector<ObjAction*> actions;
  std::map<std::string, ObjAction*> act_map;

public:
  std::set<stype> data;
  std::set<stype> prev_data;

  ScriptSet();
  static ScriptObj* create() { return new ScriptSet; }

  std::string bp_name() const { return "ScriptSet"; }

  ObjAction* action(const std::string &name) const;

  void gen_diff(bool, bool, std::string &, PlayerInfo *) const;
  bool apply_diff(bool, const char* &);

  void copy_to_prev();

private:

  stype op       (const SActParam&);
  stype op_addr  (const SActParam&);
  stype size     (const SActParam&);
  stype clear    (const SActParam&);
  stype remove   (const SActParam&);
  stype insert   (const SActParam&);
  stype intersect(const SActParam&);
  stype subtract (const SActParam&);
  stype set_union(const SActParam&);

  typedef stype (ScriptSet::*myfunc)(const SActParam&);
  void add(const std::string &name, myfunc f, sint4 objs, sint4 p, sint4 p2);
};

#endif
