#ifndef ScriptVector_H
#define ScriptVector_H

/** @file ScriptVector.H

    $Id: ScriptVector.H,v 1.17 2006/06/01 23:45:37 orts_mburo Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/libs/kernel/src/ScriptVector.H,v $
*/

// This is an ORTS file (c) Tim Furtak

#include "Global.H"
#include "GameObj.H"

class PlayerInfo;
class SActParam;

//===================================================================

class ScriptVector : public ScriptObj {

  Vector<ObjAction*> actions;
  std::map<std::string, ObjAction*> act_map;

public:
  Vector<stype> data;
  Vector<stype> prev_data;

  ScriptVector();
  static ScriptObj *create() { return new ScriptVector; }
  static const sint4 STYPE_ID;
  
  static Vector<stype> *stype_to_vecstype(const stype &s) {
    return static_cast<Vector<stype>*>(s.to_special(STYPE_ID));
  }

  std::string bp_name() const { return "ScriptVector"; }

  ObjAction* action(const std::string &name) const;
  //  ObjAction* action(sint4) const { return actions[0]; }

  void gen_diff(bool, bool, std::string &, PlayerInfo *) const;
  bool apply_diff(bool, const char* &);

  void copy_to_prev();

private:

  stype op       (const SActParam&);
  stype op_addr  (const SActParam&);
  stype size     (const SActParam&);
  stype clear    (const SActParam&);
  stype resize   (const SActParam&);
  stype push_back(const SActParam&);
  stype remove   (const SActParam&);
  stype insert   (const SActParam&);
  stype pop_back (const SActParam&);
  stype sort     (const SActParam&);
  stype setify   (const SActParam&);
  stype intersect(const SActParam&);
  stype subtract (const SActParam&);
  stype get_vect (const SActParam&);

  typedef stype (ScriptVector::*myfunc)(const SActParam&);
  void add(const std::string &name, myfunc f, sint4 objs, sint4 p, sint4 p2);

};

#endif
