#ifndef Sets_H
#define Sets_H

// $Id: Sets.H,v 1.2 2005/05/11 00:26:18 orts_mburo Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"

class ShortSet {

public:
  static const sint4 MAX_BITS = 16;

  ShortSet() { clear(); }
  
  void set(sint4 index)   { assert(ok(index)); s |= (1 << index); }
  void clear(sint4 index) { assert(ok(index)); s &= ~(1 << index); }  
  void clear() { s = 0; }
  void set()   { s = -1; }  
  bool is_set(sint4 index) { assert(ok(index)); return s & (1<<index); }
  void unite(const ShortSet& t) { s |= t.s; }
  void intersect(const ShortSet& t) { s &= t.s; }  
  
protected:  

  sint2 s;

  bool ok(sint4 index) const { return index >= 0 && index < MAX_BITS; }
};


class LongSet {

public:
  
  static const sint4 MAX_BITS = 32;

  LongSet() { clear(); }
  
  void set(sint4 index)   { assert(ok(index)); s |= (1 << index); }
  void clear(sint4 index) { assert(ok(index)); s &= ~(1 << index); }  
  void clear() { s = 0; }
  void set()   { s = -1; }  
  bool is_set(sint4 index) { assert(ok(index)); return s & (1<<index); }
  void unite(const LongSet& t) { s |= t.s; }
  void intersect(const LongSet& t) { s &= t.s; }  

protected:  

  sint4 s;

  bool ok(sint4 index) const { return index >= 0 && index < MAX_BITS; }
};

#endif

