#ifndef ShutDown_H
#define ShutDown_H

// $Id: ShutDown.H,v 1.3 2005/05/11 00:26:18 orts_mburo Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"

extern bool shut_down;

#ifndef SIGKILL
#define SIGKILL 9
#endif

static void signal_handler_shut_down(int) {
  shut_down = true; // graceful exit: let the application shut down
}

static void signal_handler_exit(int) {
  exit(20);
}

inline void signals_shut_down(bool graceful) {

  if (graceful) signal(SIGINT, signal_handler_shut_down);
  else          signal(SIGINT, signal_handler_exit);

  signal(SIGTERM, signal_handler_exit);  
  signal(SIGKILL, signal_handler_exit);
}

#endif
