// $Id: TCP_Server.C,v 1.12 2006/06/01 16:22:04 orts_mburo Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "TCP_Server.H"
#include "IO_Buffer.H"
#include "Sleep.H"

using namespace std;

TCP_Server::TCP_Server(sint4 clev_) : clev(clev_)
{
  server_socket = 0;
  terminated = false;
}

TCP_Server::~TCP_Server() {
  FORALL (clients, it) delete *it;
  close();
}

TCPsocket TCP_Server::init_listen(sint4 port)
{
  TCPsocket my_socket;
  IPaddress ip;

  FOREVER {

    if (SDLNet_ResolveHost(&ip, NULL, port) == -1) {
      REM("SDLNet_ResolveHost"); cerr << SDLNet_GetError() << endl;
      SDL_Delay(5);
      continue;
    }
  
    my_socket = SDLNet_TCP_Open(&ip);
    //System::sock_open(PF_INET, SOCK_STREAM, 0);
    if (my_socket == 0) {
      REM("SDLNet_TCP_Open"); cerr << SDLNet_GetError() << endl;
      SDL_Delay(5);
      continue;
    } 

    break;
  }

  server_socket = my_socket;
  return server_socket;
}

void TCP_Server::close()
{
  if (server_socket) {
    REM("close server socket");
    SDLNet_TCP_Close(server_socket);
    server_socket = 0;
  }
}


IO_Buffer *TCP_Server::new_client(TCPsocket so, sint4 clev_) const
{
  return new IO_Buffer(so, clev_); // no delay in server
}


bool TCP_Server::handle_connection()
{
  TCPsocket s;
  s = SDLNet_TCP_Accept(server_socket);
  if (!s) return false;

#if 0
  
  // get the client's IP and port number
  remoteip = SDLNet_TCP_GetPeerAddress(s);
  if (!remoteip) {
    printf("SDLNet_TCP_GetPeerAddress: %s\n", SDLNet_GetError());
    continue;
  }

  // print out the clients IP and port number
  ipaddr = SDL_SwapBE32(remoteip->host);
  printf("Accepted a connection from %d.%d.%d.%d port %hu\n",
	 ipaddr >> 24,
	 (ipaddr >> 16) & 0xff,
	 (ipaddr >> 8) & 0xff,
	 ipaddr & 0xff,
	 remoteip->port);
#endif
  
  IO_Buffer *p_client = new_client(s, clev);

  if (p_client == 0) {
    REM("!!! no free slot");
    SDLNet_TCP_Close(s); return false;
  }

  clients.push_back(p_client);
    
  // sprintf(p_client->host, "%s", (he ? he->h_name : dotted));

  // cout << "client connected" << endl;
  return true;
}



#if 0

  sint4 numready;
  SDLNet_SocketSet set;
   
numready=SDLNet_CheckSockets(set, 1000);
if (numready==-1) {
    printf("SDLNet_CheckSockets: %s\n", SDLNet_GetError());
    //most of the time this is a system error, where perror might help you.
    perror("SDLNet_CheckSockets");
} else if(numready) {
    printf("There are %d sockets with activity!\n",numready);
    // check all sockets with SDLNet_SocketReady and handle the active ones.
    if(SDLNet_SocketReady(serversock)) {
        client=SDLNet_TCP_Accept(serversock);
        if(client) {
            // play with the client.
        }
    }
#endif


#if 0
static sint4 my_set_sock_opt(sint4 s, sint4 cmd, sint4 opt, bool report=true)
{
  sint4 ok = setsockopt(s, SOL_SOCKET, cmd, &opt, sizeof(opt));
  if (report && ok < 0) ERR("set_socket_opt failed"); 
  return ok;
}


static sint4 my_set_fl(sint4 f, sint4 flags, bool report=true)
{ 
  sint4 val = System::fcntl_arg(f, F_GETFL, 0);
  val |= flags;
  sint4 ok = System::fcntl_arg(f, F_SETFL, val);
  if (report && ok < 0) ERR("my_set_fcntl failed");
  return ok;
}

  
  
  // read the buffer from client
  len = SDLNet_TCP_Recv(client,message,1024);
  SDLNet_TCP_Close(client);
  
...
  
  fd_set         readfds;
  sint4            i;
  struct timeval timeout;
    
  timeout.tv_sec  = 0;
  timeout.tv_usec = 0;
  FD_ZERO(&readfds);
  FD_SET(server_socket, &readfds);

  i = System::select_desc(server_socket+1,
			  readfds, *(fd_set*)0, *(fd_set*)0, &timeout);

  if (i < 0 && errno != EINTR) ERR("select connect");

  if (i < 0) REM("connect select error");
  if (i > 0) {
    accept_connection();
    return true;
  }

  return false;


#endif

    
