#ifndef OSimpleTerrainWidget_H
#define OSimpleTerrainWidget_H

// $Id: ODemo_SimpleTerrainWidget.H,v 1.1 2006/05/31 22:30:56 orts_mburo Exp $

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "Global.H"
#include "EventHandler.H"

#include "Demo_SimpleTerrain.H"
#include "Demo_ST_SimpleMap.H"
#include "OCGridBase.H"
#include "ODrawOnTerrain.H"

class GfxModule;

//===================================================================

namespace Demo_SimpleTerrain {

  class SimpleTerrainOverlay : public EventHandler {
  private:
    const SimpleMap<SizeCell> *map, *gnd_map, *air_map;

    const ST_Terrain *st_terrain;
    DrawOnTerrain dot;
    bool enabled;

    GfxModule *gfxm;

  public:

    SimpleTerrainOverlay(const ST_Terrain &terrain, GfxModule &gfxm);

    bool is_enabled() const { return enabled; }
    void enable() { enabled = true; }
    void disable() { enabled = false; }
    void draw();

    bool handle_event(const Event &e);
  };

  //-----------------------------------------------------------------

  class SimpleTerrainWidget : public CGridBase
  {
  private:
    const SimpleMap<SizeCell> *map, *gnd_map, *air_map;

    sint4 wwidth;
    sint4 wheight;

    bool draw_tiles;
    bool draw_air;

    const ST_Terrain *st_terrain;
    SimpleTerrainOverlay *overlay;

  public:

    SimpleTerrainWidget(const ST_Terrain &terrain, GfxModule *gfxm=0);
    ~SimpleTerrainWidget();

    virtual stype event_key_down(stype key, stype mod, stype x, stype y);
    virtual stype draw();
  };

}

//===================================================================

#endif
