#ifndef OFrustum_H
#define OFrustum_H

// $Id: OFrustum.H,v 1.1 2006/05/31 22:30:56 orts_mburo Exp $
 
// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"

class Coor3;

class Frustum
{
public:

  void compute();
  bool aabox_intersects(const Coor3 &o, const Coor3 &d);
  bool sphere_intersects(const Coor3 &o, real4 radius);
  bool point_intersects(const Coor3 &o);

  real4 m_Frustum[6][4];

protected:

  enum { A, B, C, D };
  enum { RIGHT, LEFT, BOTTOM, TOP, BACK, FRONT };

  void normalize_plane(real4 frustum[6][4], sint4 side);
};

#endif
