#ifndef OLayoutHV_H
#define OLayoutHV_H

// $Id: OLayoutHV.H,v 1.1 2006/05/31 22:30:57 orts_mburo Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

/*
  layout rectangle recursively

  string format:

  <format> ::=  (H|V)(<number-of-successors [:<weight>]* [, <format>]* )

  examples:

    2x2:                        "V(2, H(2, V(0), V(0)), H(2, V(0), V(0)))"
    2-top-1-bottom (2:3 ratio): "V(2:2:3, H(2, V(0),V(0)), H(0))"
*/

#include "Global.H"

class LayoutHV
{
public:

  typedef SDL_Rect R;

  // format string + rectangle + space between rectangles -> vector of rectangles
  static void parse(const std::string &s, const R &r, sint4 space, Vector<R> &rects);

private:
  
  enum { ANY, V, H };

  static void parse(std::istringstream &is, const R &r, sint4 space, Vector<R> &rects,
		    sint4 mode=ANY);
};

#endif
