#ifndef OSoundMixer_H
#define OSoundMixer_H

// $Id: OSoundMixer.H,v 1.1 2006/05/31 22:30:57 orts_mburo Exp $
 
// This is an ORTS file (c) Michael Buro, licensed under the GPL
// based on 

#include "Global.H"
#include "SDL.h"
#include "SDL_audio.h"


extern int sound_test(const std::string &path);


struct Sound
{
  Uint8 *data;
  Uint32 length;
  
  Sound() { data = 0; length = 0; }
  ~Sound();
};


class SoundMixer {

public:

  struct Voice
  {
    sint2 *data;
    uint4 length;
    uint4 position;
    sint2 vol[2]; // 0:left 1:right
  };

  Vector<Voice> voices;
  SDL_AudioSpec audiospec;
  bool die;

  SoundMixer() { is_open = false; }

  uint4 play(Sound &sound, real4 lvol, real4 rvol);

  // return 0 <=> OK
  sint4 open();

  void close();

  // return 0 <=> OK
  static sint4 load_sound(const std::string &filename, Sound &sound);

protected:
  
  static void flip_endian(uint1 *data, uint4 length);

private:

  bool is_open;
};

#endif

