#ifndef SWidget_H
#define SWidget_H

/** @file SWidget.H
    Onscreen display for pathfinding.

    $Id: SWidget.H,v 1.6 2006/03/23 04:54:01 orts_mburo Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/libs/path/src/SWidget.H,v $
*/

#include "CWidget.H"
#include "SimpleMap.H"
#include "GfxGlobal.H"
#include "Environment1.H"
#include "PathProcessor.H"

/** Display panel for pathfinding search. */

class SWidget : public CWidget {
    
public:
    
  SWidget();
  ~SWidget();
  
  virtual stype event_key_down(stype key, stype mod, stype x, stype y);
  virtual stype draw();

  void set_env(Environment *env);
  void set_pp(PathProcessor *pp) { this->pp = pp; }
  void set_tp(int tp) { tile_points = tp; };
  
private:

  SimpleMap<SizeCell> *map;
  PathProcessor *pp;
  Environment *env;

  int wwidth;
  int wheight;
  int tile_points;

  bool draw_tiles;
  bool air_map;
};

#endif
