//-----------------------------------------------------------------------------
/** @file error.h
    Base exception class.

    $Id: error.h,v 1.2 2004/11/20 01:10:31 orts_nathanst Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/libs/pathfind/src/error.h,v $
*/
//-----------------------------------------------------------------------------

#ifndef PATHFIND_ERROR_H
#define PATHFIND_ERROR_H

#include <exception>
#include <string>
#include <vector>

//-----------------------------------------------------------------------------

namespace PathFind
{
    using namespace std;

    /** Base class for exceptions. */
    class Error
        : public exception
    {
    public:
        Error()
        { }

        Error(const string& _what)
            : m_message(_what)
        { }

        ~Error() throw();
        
        void setMessage(const string& message)
        {
            m_message = message;
        }

        const char* what() const throw()
        {
            return m_message.c_str();
        }
        
    private:
        string m_message;
    };
}

//-----------------------------------------------------------------------------

#endif
