/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
  $Header: /usr/bodo1/cvs/cvs/orts3/misc/orts1/BoolMatrix.H,v 1.1.1.1 2004/10/11 09:09:18 orts_mburo Exp $
  $Log: BoolMatrix.H,v $
  Revision 1.1.1.1  2004/10/11 09:09:18  orts_mburo
  foo

  Revision 1.1.1.1  2003/06/11 22:04:54  orts_mburo
  import

*/

#ifndef BoolMatrix_H
#define BoolMatrix_H

#include "Global.H"
#include <vector>

class BoolMatrix {

protected:
  
  sint4 nx, ny;
  vector<vector<bool> > m; // slow, but easy to copy :)

public:
  
  BoolMatrix(sint4 nx_ = 2, sint4 ny_ = 2) {
    assert(nx_ >= 1 && ny_ >= 1);
    nx = nx_; ny = ny_;
    m.reserve(nx);
    FORS (x, nx) {
      vector<bool> mx;
      mx.reserve(ny);
      FORS (y, ny) mx.push_back(false);
      m.push_back(mx);
    }
  }

  virtual ~BoolMatrix() {}

  bool get(sint4 x, sint4 y) {
    assert(x >= 0 && x < nx && y >= 0 && y < ny);
    return m[x][y];
  }

  void set(sint4 x, sint4 y, bool f) {
    assert(x >= 0 && x < nx && y >= 0 && y < ny);
    m[x][y] = f;
  }
};
 
#endif
