#ifndef ClusterSquads_H
#define ClusterSquads_H

/** @file ClusterSquads.H
*/

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "Global.H"
#include "EventHandler.H"

class GameStateModule;
class GameChanges;
class GameObj;
class ClusterSquad;

//===================================================================

class ClusterSquads : public EventHandler
{
protected:
  GameStateModule &gsm;

  Vector<ClusterSquad*> squads; ///< One for each player.

  void update();
  void init();

  sint4 num_player;
  bool initialized;

  bool enabled;
  
public:
  ClusterSquads(GameStateModule &gsm);
  ~ClusterSquads();

  bool handle_event(const Event &e);

  bool is_enabled() const { return enabled; }
  void enable()  { enabled = true; }
  void disable() { enabled = false; }

  friend class ClusterSquadsWidget;
};

//===================================================================

#endif
