#ifndef TerrainVectorField_H
#define TerrainVectorField_H

// $Id: TerrainVectorField.H,v 1.2 2006/06/05 05:31:33 orts_furtak Exp $

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "Global.H"
#include "VectorField.H"
#include "EventHandler.H"

class GameStateModule;
class GameChanges;

//===================================================================

class TerrainVectorField : public VectorField, public EventHandler
{
protected:
  GameStateModule &gsm;

  sint4 mh, mw;
  sint4 *marked;

public:
  TerrainVectorField(GameStateModule &gsm);
  ~TerrainVectorField();
  
  Vec2<real4> field(real4 x, real4 y, real4 dx=0, real4 dy=0) const;
  void draw(DrawOnTerrain &dot, const Game &game, const Vec3<real4> &color) const;
  
  bool handle_event(const Event &);
  void update(const GameChanges &changes);

  friend class SquadCombatAIOverlay;
};

//===================================================================

#endif
