// $Id: BuildTasks.cpp,v 1.11 2006/06/16 02:06:52 dtom Exp $


#include "BuildTasks.h"

#include "BuildTasksAI.h"
#include "BuildTasksState.h"
#include "Random.H"
#include "GameStateModule.H"
#include "Game.H"
#include "GameChanges.H"
#include "GameObj.H"
#include "GfxModule.H"
#include "TerrainModule.H"
#include "TerrainClassifier.H"

//REMEMBER TO MOVE THE BUILD LOCATION CODE TO THE STATE CLASS AND GENERALIZE
namespace BSimul {

#define DEFINE_BTASK(name)						\
  name::name(uint4 playerID,BuildTasksState* state,ObjectVector& origObjects,	\
	     TaskCreateFunctionPtr f,std::string n,real8 timeout,MoveStruct* extraData) : \
    Task(playerID,state,origObjects,f,n,timeout,extraData){	\
    exec();								\
  }									\
    name::name(Task* parent,ObjectVector& origObjects,TaskCreateFunctionPtr function,std::string n, \
	       real8 timeout,MoveStruct* extraData) :	\
      Task(parent,origObjects,function,n,timeout,extraData){ \
      exec();								\
    }									\
    name::name(const name& t) : Task(t){}				\
    Task* name::clone(BuildTasksState* state,Task* newParent){		\
      name* newTask = new name(*this);					\
      newTask->parent = newParent;					\
      newTask->state = state;						\
      FORALL(children,it){						\
	newTask->children.push_back((*it)->clone(state,newTask));	\
      }									\
      return newTask;							\
    }									\
    bool name::exec()

  /*
  DEFINE_TASK(SpreadAttack) {
    ObjectVector temp;

    switch(lineNum) {
    case 0:
      // need a copy of this vector, since the constructor for tasks modifies the original by removing objects from it
      temp = objects;

      FORALL(temp, it) {
        ObjectVector object;
	object.push_back(*it);

        GameObj* nearestBase = state->getNearestEnemyBaseOfGroup(object);
	if(nearestBase != NULL) {
	  new Attack(this,object,function,name,new MoveStruct(nearestBase));

	}else{

	  if(children.empty()){
	    return true;
	  }else{
  	    ++lineNum;
	    return false;
	  }
	}

      }
      return false;
    default:
      return true;
    }
  }
  */

 //  DEFINE_BTASK(TrainWorkers){
//     switch(lineNum){
//     case 0: {	
   
//       cout << "CREATE WORKER \m"
//       ++lineNum;
//       return false;
//     }
//     default: 
//       return true;
//     }


//   }


//   DEFINE_BTASK(WorkerRush){

//     switch(lineNum){
//     case 0: {					
//       // Send all of our starting workers out to gather minerals.
//       ExtraObjectData newData;
//       newData.isDone=true;
//       FORALL(objects, it){
// 	state->getFriendlyUnits()[(*it)] = newData;
//       }
//       // Create as many workers as we can 
//       new TrainWorkers(this, simulationState, simulationState->getCC(),function, name, 0.0, extraData);
  


//       ++lineNum;
//       return false;
//     }
//     default: 
//       return true;
//     }

//   }

  DEFINE_BTASK(BuildandTrain) {
    fprintf(stderr, "BUILD AND TRAIN\n");
    ObjectVector builder;
    builder.push_back(objects[0]);
    switch(lineNum){
    case 0:{
      fprintf(stderr, "checking etc\n");
      fprintf(stderr, "size of vector: %d\n", builder.size());
      if(!(builder[0]->get_int("is_mobile"))) return false;
      ExtraObjectData builderData;
      state->getFriendlyUnits()[builder[0]] = builderData;
      state->autogatherer->removeW(builder);      

      new MovetoBuild(this, builder, function, name, 0.0, extraData);
      //new Scout(this, builder, function, name, 0.0, extraData);
      fprintf(stderr, "bet you i don't show\n");
      ++lineNum;
      return false;
    }
    case 1:{
      fprintf(stderr, "building\n");
      new BuildBarracks(this, builder, function, name, 0.0, extraData);
       ++lineNum;
      return false;
    }
    default: 
      fprintf(stderr, "does reach default\n");
      return true;
    }

  }

  DEFINE_BTASK(MovetoBuild){
    fprintf(stderr, "MOVE TO BUILD\n");
    ObjectVector temp;

    sint4 x, y, j, k;
    x=0;
    y=0;
    bool found=false;
    bool good=true;      
    temp=objects;
    GameObj* builder = temp[0];

    builder->get_center(x,y);
    mapTerrain::TerrainMap terrMap(&state->gsm->get_game());
    TerrainBase::Loc loc(0,0);
    TerrainBase::Loc start(x,y);
    

    switch(lineNum){
    case 0:
 
      found = terrMap.find_free_loc(start, loc, 256, 3); 
      terrMap.print_map();
      fprintf(stderr, "\n");
      if(found){
	//	fprintf(stderr,"x: %d, y: %d\n", x*16, y*16);
	TerrainBase::Task task(TerrainBase::Goal::LOCATION, TerrainBase::Goal::TOUCH,
                           TerrainBase::Task::INDIVIDUAL);

	std::cout << "i = " << loc.x << "j = " << loc.y << std::endl; 
	std::cout << "tile : (" << loc.x / 16 << "," << loc.y / 16 << ")" << std::endl;

	task.goal.loc = loc;
	task.objs.insert(builder);
	state->simAI->doPath(task);
	ExtraObjectData newData;
	newData.location = task.goal.loc;
        newData.state = ExtraObjectData::BUILD;
	state->getFriendlyUnits()[builder] = newData;
	fprintf(stderr, "path assigned\n");
	lineNum++;
	return false;
      }
      else{
	fprintf(stderr, "trying to scout\n");
	//new Scout(this, temp, function, name, 0.0, extraData);
	return false;
      }
    default:
      return true;
    }
  }
  
  DEFINE_BTASK(BuildControlCenter){
    ObjectVector temp;
    temp=objects;
    sint4 x, y;
    GameObj* builder = temp[0];
    switch(lineNum) {
    case 0:{
      builder->get_center(x,y);
      Vector<sint4> args;
      args.push_back(x);
      args.push_back(y);
      builder->set_action("build_controlCenter", args);
      
      ++lineNum;
      return false;
    }
    case 1:{
      builder->get_center(x,y);
      if(builder->get_int("is_mobile")){
	builder->get_center(x,y);
	Vector<sint4> args;
	args.push_back(x);
	args.push_back(y);
	builder->set_action("build_controlCenter", args);
	break;
      }
      state->addNewBuilding(builder);
      ++lineNum;
      return false;
    }
    default:
      return true;
    }
    return false;
  }

  DEFINE_BTASK(BuildBarracks){
    std::cout << "Build barracks" << std::endl; 

    ObjectVector temp;
    temp=objects;
    sint4 x, y;
    GameObj* builder = temp[0];
    static sint4 tries = 0;

    switch(lineNum) {
    case 0:{
      builder->get_center(x,y);
      Vector<sint4> args;
      args.push_back(x);
      args.push_back(y);
      builder->set_action("build_barracks", args);
    
      ++lineNum;
      return false;
    }
    case 1:{
      tries++;
      builder->get_center(x,y);
      if(builder->get_int("is_mobile")){
	builder->get_center(x,y);
	Vector<sint4> args;
	sint4 xprime, yprime;
	if(tries % 2 == 0){
	  xprime = x + (sint4)(state->rand.rand_uint4() % 32);
	  yprime = y + (sint4)(state->rand.rand_uint4() % 32);
	}
	else{
	  xprime = x - (sint4)(state->rand.rand_uint4() % 24);
	  yprime = y - (sint4)(state->rand.rand_uint4() % 24);
	}

	args.push_back(xprime);
	args.push_back(yprime);
	builder->set_action("build_barracks", args);
	break;
      }
      state->addNewBuilding(builder);
      ++lineNum;
      return false;
    }
    default:
      return true;
    }
    return false;
  }

  DEFINE_BTASK(BuildFactory){
    ObjectVector temp;
    temp=objects;
    sint4 x, y;
    GameObj* builder = temp[0];
    switch(lineNum) {
    case 0:{
      builder->get_center(x,y);
      Vector<sint4> args;
      args.push_back(x);
      args.push_back(y);
      builder->set_action("build_factory", args);
    
      ++lineNum;
      return false;
    }
    case 1:{
      builder->get_center(x,y);
      if(builder->get_int("is_mobile")){
	builder->get_center(x,y);
	Vector<sint4> args;
	args.push_back(x);
	args.push_back(y);
	builder->set_action("build_factory", args);
	break;
      }
      state->addNewBuilding(builder);
      ++lineNum;
      return false;
    }
    default:
      return true;
    }
    return false;
  }
  
  DEFINE_BTASK(TrainMarine){
    switch(lineNum) {
    case 0:{
      FORALL(objects, it){
	Vector<sint4> args;
	if((*it)->get_int("task_done")!=0) continue;
	(*it)->set_action("train_marine", args);
	state->getFriendlyUnits()[(*it)].isDone=true;
	++lineNum;
	return false;
      }
	
      return false;
    }
    default:
      return true;
    }
  }
  
  DEFINE_BTASK(TrainTank){
    switch(lineNum) {
    case 0:{
      FORALL(objects, it){
	Vector<sint4> args;
	if((*it)->get_int("task_done")!=0) continue;
	(*it)->set_action("build_tank", args);
	state->getFriendlyUnits()[(*it)].isDone=true;
	++lineNum;
	return false;
      }
      
      return false;
    }
    default:
      return true;
    }
  }
  
  DEFINE_BTASK(TrainWorker){
    switch(lineNum) {
    case 0:{
      FORALL(objects, it){
	Vector<sint4> args;
	if((*it)->get_int("task_done")!=0) continue;
	(*it)->set_action("train_worker", args);
	state->getFriendlyUnits()[(*it)].isDone=true;
	++lineNum;
	return false;
      }
	
      return false;
    }
    default:
      return true;
    }
  }

  DEFINE_BTASK(Scout){
    switch(lineNum){
    case 0:{
      sint4 x,y;
      bool found=false;
      FORALL(objects, it){
	objects[0]->get_center(x,y);
	mapTerrain::TerrainMap terrMap(&state->gsm->get_game());
	TerrainBase::Loc loc(0,0);
	TerrainBase::Loc start(x,y);
	found=terrMap.get_random_unexplored_point(start, loc,0,0);
	TerrainBase::Task task(TerrainBase::Goal::LOCATION, TerrainBase::Goal::TOUCH, 
			       TerrainBase::Task::INDIVIDUAL);    
	task.goal.loc = loc;
	task.objs.insert(*it);
	state->simAI->doPath(task);
	ExtraObjectData newData;
	newData.location = task.goal.loc;
	newData.state = ExtraObjectData::SCOUT;
	state->getFriendlyUnits()[(*it)] = newData;
	return false;
      }
	  
      return true;
    }
    default:
      return true;
    }
  }

  DEFINE_BTASK(Harass){
    fprintf(stderr, "harass\n");
    switch(lineNum){
    case 0:{
      TerrainBase::Loc target=state->getNearestEnemyControlCenter(objects);
      fprintf(stderr, "number of bases: %d\n",  state->getEnemyBases().size());
      FORALL(objects, it){
	TerrainBase::Task task(TerrainBase::Goal::LOCATION, TerrainBase::Goal::VICINITY,
                           TerrainBase::Task::INDIVIDUAL);


	task.goal.loc = target;
	task.goal.distance=4*16;
	task.objs.insert((*it));
	state->simAI->doPath(task);
	ExtraObjectData newData;
	newData.location = task.goal.loc;
        newData.state = ExtraObjectData::POSITIONING;
	state->getFriendlyUnits()[(*it)] = newData;
      }
      ++lineNum;
      return false;
    }
    case 1:{
      GameObj* workertarget=state->getNearestEnemyWorker(objects);
      FORALL(objects, it){
	if(state->getFriendlyUnits()[(*it)].state==ExtraObjectData::HARASS){
	  TerrainBase::Task task(TerrainBase::Goal::OBJ, TerrainBase::Goal::TOUCH,
                           TerrainBase::Task::INDIVIDUAL);
	  task.goal.obj = workertarget;
	  task.objs.insert((*it));
	  state->simAI->doPath(task);
	  ExtraObjectData newData;
	  newData.target = workertarget;
	  newData.state = ExtraObjectData::HARASS;
	  state->getFriendlyUnits()[(*it)] = newData;
	}
	else if(state->getFriendlyUnits()[(*it)].state==ExtraObjectData::FLEE){
	  if(state->noEnemyInRange((*it)))
	    state->getFriendlyUnits()[(*it)].state=ExtraObjectData::POSITIONING;
	}
	else if(state->getFriendlyUnits()[(*it)].state==ExtraObjectData::POSITIONING){
	  TerrainBase::Loc target=state->getNearestEnemyControlCenter(objects);
	  TerrainBase::Task task(TerrainBase::Goal::LOCATION, TerrainBase::Goal::VICINITY,
				 TerrainBase::Task::INDIVIDUAL);
	   
	  task.goal.loc = target;
	  task.goal.distance=4*16;
	  task.objs.insert((*it));
	  state->simAI->doPath(task);
	  ExtraObjectData newData;
	  newData.location = task.goal.loc;
	  newData.state = ExtraObjectData::POSITIONING;
	  state->getFriendlyUnits()[(*it)] = newData;
	}
      }
      return false;
    }
    default:
      return true;
    }    
  }
  
  DEFINE_BTASK(MassAttack){
    TerrainBase::Loc target=state->getNearestEnemyControlCenter(objects);
    switch(lineNum){
    case 0:{
      FORALL(objects, it){
	TerrainBase::Task task(TerrainBase::Goal::LOCATION, TerrainBase::Goal::VICINITY,
			       TerrainBase::Task::INDIVIDUAL);
	
	task.goal.loc = target;
	task.goal.distance=4*16;
	task.objs.insert((*it));
	state->simAI->doPath(task);
	ExtraObjectData newData;
	newData.location = task.goal.loc;
	newData.state = ExtraObjectData::ATTACK;
	state->getFriendlyUnits()[(*it)] = newData;
      }
      lineNum++;
      return false;
    }
    case 1:{
      GameObj* workertarget=state->getNearestEnemyWorker(objects);
      FORALL(objects, it){
	TerrainBase::Task task(TerrainBase::Goal::OBJ, TerrainBase::Goal::TOUCH,
			       TerrainBase::Task::INDIVIDUAL);
	task.goal.obj = workertarget;
	task.objs.insert((*it));
	state->simAI->doPath(task);
	ExtraObjectData newData;
	newData.target = workertarget;
	newData.state = ExtraObjectData::ATTACK;
	state->getFriendlyUnits()[(*it)] = newData;
      }
      return false;
    }
    default:
      return true;
    }
  }
  
  /*
  Task* createAttackAndDefend(uint4 id, BuildTasksState* s, ObjectVector& o,real8 timeout){
    return new MassAttack(id,s,o,createAttackAndDefend,"AttackAndDefend",timeout);
  }
  */
  Task* createBuildandTrain(uint4 id, BuildTasksState* s, ObjectVector& o,real8 timeout){
    return new BuildandTrain(id,s,o,createBuildandTrain,"BuildandTrain",timeout);
  }
  Task* createHarass(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout){
    return new Harass(id,s,o,createHarass,"Harass",timeout);
  }
  Task* createTrainMarine(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout){
    fprintf(stderr, "spamming marines now\n");
    return new TrainMarine(id,s,o,createTrainMarine,"TrainMarine",timeout);
  }
  Task* createTrainTank(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout){
    return new TrainTank(id,s,o,createTrainTank,"TrainTank",timeout);
  }
  Task* createTrainWorker(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout){
    fprintf(stderr, "spamming workers still\n");
    return new TrainWorker(id,s,o,createTrainWorker,"TrainWorker",timeout);
  }

}



