/*
 * $Id: graphAbstraction.cpp,v 1.1 2006/05/09 17:58:46 nicholas Exp $
 *
 *  graphAbstraction.cpp
 *  HOG
 *
 *  Created by Nathan Sturtevant on 1/11/05.
 *  Copyright 2005 Nathan Sturtevant. All rights reserved.
 *
 */

using namespace std;

#include "graphAbstraction.h"
using namespace HOG;

enum {
	kQuiet = 0x00,
	kBuildGraph = 0x01,
	kRepairGraph = 0x02,
	kMiscMessages = 0x04
};

const int verbose = kQuiet;//kRepairGraph;

void graphAbstraction::getParentHierarchy(node *from, node *to,
																					std::vector<node *> &fromChain,
																					std::vector<node *> &toChain)
{
  //	while (from->getLabelL(kParent) != to->getLabelL(kParent))
  while (!abstractions[from->getLabelL(kAbstractionLevel)]->
				 findEdge(from->getNum(), to->getNum()) &&
				 //(from->getLabelL(kParent) != to->getLabelL(kParent))
				 (from != to)) {
    fromChain.push_back(from);
    toChain.push_back(to);
		
    from = abstractions[from->getLabelL(kAbstractionLevel)+1]->
      getNode(from->getLabelL(kParent));
		
    to = abstractions[to->getLabelL(kAbstractionLevel)+1]->
      getNode(to->getLabelL(kParent));
		
    if (verbose&kBuildGraph)
			printf("getParentHierarchy: Moving to nodes #%d and %d\n",
						 from->getNum(), to->getNum());
  }
  fromChain.push_back(from);
  toChain.push_back(to);
}

// get nth-level parent of which node
node *graphAbstraction::getNthParent(node *which, int n)
{
	while ((which != NULL) && (which->getLabelL(kAbstractionLevel) < n))
	{
		int nextLevel = which->getLabelL(kAbstractionLevel)+1;
		graph *g = abstractions[nextLevel];
		which = g->getNode(which->getLabelL(kParent));
	}
	return which;
}

