// $Id: heap.h,v 1.1 2006/05/09 17:58:46 nicholas Exp $

// HOG File

#ifndef HEAP_H
#define HEAP_H

#include <vector>
#include <list>

#define DEFAULT_SIZE 10
#include "graph.h"

/**
 * A simple & efficient heap class which uses graph objects.
 */

namespace HOG{

class heap {
public:
  heap(int s = DEFAULT_SIZE);
  ~heap();
  void add(graph_object *val);
  void decreaseKey(graph_object *val);
  bool isIn(graph_object *val);
  graph_object *remove();
  bool empty();
private:
  void heapifyUp(int index);
  void heapifyDown(int index);
  std::vector<graph_object *> _elts;
  int count;
};
}
#endif
