/*
 * $Id: mapAbstraction.h,v 1.1 2006/05/09 17:58:46 nicholas Exp $
 *
 *  mapAbstraction.h
 *  hog
 *
 *  Created by Nathan Sturtevant on 6/3/05.
 *  Copyright 2005 Nathan Sturtevant, University of Alberta. All rights reserved.
 *
 */

#include "map.h"
#include "graphAbstraction.h"
#include "glUtil.h"
#include "constants.h"

#ifndef MAPABSTRACTION_H
#define MAPABSTRACTION_H

/**
* This class is designed as an interface to be added onto any type of graphAbstraction
 * to support a few extra functionalities that mapabstractions should have.
 */
namespace HOG{

class mapAbstraction : public graphAbstraction {
public:
	mapAbstraction(Map *_m) :m(_m), levelDraw(0) {}
	virtual ~mapAbstraction();
	node *getNodeFromMap(int x, int y, tCorner c = kNone)
	{ return abstractions[0]->getNode(m->getNodeNum(x, y, c)); }
	void getTileFromNode(node *n, int &x, int &y);
	void getRandomTileFromNode(node *n, int &x, int &y);
	/** Given a location (recVec) return the tile under that location */
	void getTileUnderLoc(int &x, int &y, const recVec &);

	Map* getMap() { return m; }
	
	virtual double h(node *a, node *b);
	
	// display functions
	virtual void openGLDraw();
	void toggleDrawAbstraction(int which);
	void clearMarkedNodes();
	recVec getNodeLoc(node *n);
private:
		
	void drawLevelConnections(node *n);
	void drawGraph(graph *g);
	
	Map *m;
	unsigned long levelDraw;
};

graph *getMapGraph(Map *m);
void addMapEdges(Map *m, graph *g, int x, int y);
}
#endif
