#ifndef SI_BASE_H
#define SI_BASE_H

// $Id: SI_Base.h,v 1.4 2006/05/31 16:49:26 sailer Exp $

#include "SI_MapObject.h"

namespace Simul{

  const real8 SI_BASE_SIZE_DIVISOR=10.0;

  class Base : public MapObject{

  public:
    Base(uint4 playerID,uint4 hp);

    Base* clone() const;

    bool withinRange(Group* otherObject);

    real8 getHitPoints() const { return hitPoints;}

    void setHitPoints(real8 hitPoints){
      this->hitPoints = hitPoints;
      recalculateExtents();
    }

    void recalculateExtents() {  extents = (sqrt(hitPoints)/SI_BASE_SIZE_DIVISOR);}

    real8 getExtents() const {return extents;}

  private:
    real8 hitPoints;

    real8 extents;
  };
}
#endif
