#ifndef SI_STRATEGIES_H
#define SI_STRATEGIES_H

// $Id: SI_Strategies.h,v 1.12 2006/06/16 01:56:46 jbergsma Exp $

#include "SI_Task.h"

#define DECLARE_TASK(name)						\
  class name : public Task{						\
  public:								\
    name(uint4 playerID,SimulationState* state,ObjectVector& origObjects,	\
	 TaskCreateFunctionPtr f,std::string name,real8 timeout,MoveStruct* extraData = NULL); \
    name(Task* parent,ObjectVector& origObjects,TaskCreateFunctionPtr function,std::string name, \
	 real8 timeout, MoveStruct* extraData = NULL); \
    name(const name&);							\
    Task* clone(SimulationState* state, Task* parent);			\
    bool exec();							\
  }

namespace Simul {
  class SimulationState;

  DECLARE_TASK(MassAttack);
  DECLARE_TASK(SpreadAttack);
  DECLARE_TASK(HalfUnitsBaseDefence_MassAttack);

  // internal tasks, don't use these explicitly right now

  DECLARE_TASK(Join);
  DECLARE_TASK(Attack);
  DECLARE_TASK(MoveToLocation);
  DECLARE_TASK(MoveToObject);
  DECLARE_TASK(DefendObject);
  DECLARE_TASK(TouchObj);
  DECLARE_TASK(JoinAndMoveToObj);
  DECLARE_TASK(SmartJoin);
  DECLARE_TASK(Hunter);
  DECLARE_TASK(Hunter2);
  DECLARE_TASK(JoinAndHunt);
  DECLARE_TASK(JoinAndHunt2);
  DECLARE_TASK(JoinSpreadAttack);
  DECLARE_TASK(JoinAndAttack);

// these declarations are only needed for the very highest level tasks

//Task* createMassAttack_unitsFirst(uint4 id,SimulationState* s,GroupVector& g);
//Task* createSpreadAttack_baseFirst(uint4 id,SimulationState* s,GroupVector& g);
  Task* createSpreadAttack(uint4 id,SimulationState* s,ObjectVector& o,real8 timeout);
  Task* createMassAttack(uint4 id,SimulationState* s,ObjectVector& o,real8 timeout);
  Task* createHalfUnitsBaseDefence_MassAttack(uint4 id,SimulationState* s,ObjectVector& o,real8 timeout);
  Task* createHunter(uint4 id,SimulationState* s,ObjectVector& o,real8 timeout);
  Task* createHunter2(uint4 id,SimulationState* s,ObjectVector& o,real8 timeout);
  Task* createJoinSpreadAttack(uint4 id,SimulationState* s,ObjectVector& o,real8 timeout);
  TerrainBase::Loc find_a_spot(TerrainBase::Loc center_loc, GameStateModule& gsm);
  // NOTE: maybe make these available to be made explicitly instead of just being made by the above tasks, not now though
  /*
    Task* createJoin();
    Task* createAttack();
    Task* createMove();
  */

  // FIXME any better way to do this?  a dynamic size?
  const uint4 NUM_STRATEGIES = 7;
  const TaskCreateFunctionPtr strategyList[] = {
    NULL,
    createMassAttack,
    createSpreadAttack,
    createHalfUnitsBaseDefence_MassAttack,
    createHunter,
    createHunter2,
    createSpreadAttack
  };

}
#endif

